.686
.model flat,stdcall
option casemap:none

include .\stdlib.inc

.code

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

; AMD MANUAL
; 64-Bit Multiplication
; llmul computes the low-order half of the product of its
;  arguments, two 64-bit integers.
;
; In:       [ESP+8]:[ESP+4] = multiplicand
;           [ESP+16]:[ESP+12] = multiplier
; Out:      EDX:EAX = (multiplicand * multiplier) % 2^64
; Destroys: EAX, ECX, EDX, EFlags
Int64Mul proc ull1:QWORD,ull2:QWORD
	mov edx, [esp+8]    ; multiplicand_hi
	mov ecx, [esp+16]   ; multiplier_hi
	or  edx, ecx        ; One operand >= 2^32?
	mov edx, [esp+12]   ; multiplier_lo
	mov eax, [esp+4]    ; multiplicand_lo
	jnz twomul          ; Yes, need two multiplies.
	mul edx             ; multiplicand_lo * multiplier_lo
	ret                 ; Done, return to caller.
twomul:
	imul edx, [esp+8]         ; p3_lo = multiplicand_hi * multiplier_lo
	imul ecx, eax             ; p2_lo = multiplier_hi * multiplicand_lo
	add  ecx, edx             ; p2_lo + p3_lo
	mul  dword ptr [esp+12]   ; p1 = multiplicand_lo * multiplier_lo
	add  edx, ecx             ; p1 + p2_lo + p3_lo = result in EDX:EAX
	ret  4*4                  ; Done, return to caller.
Int64Mul endp

OPTION PROLOGUE:PROLOGUEDEF 
OPTION EPILOGUE:EPILOGUEDEF

end
